/** ****************************************************************************
 *   GxFreeGUI_Paint
 *    Author: Jan Szemiet
 *    Version: 0.1
 *  ****************************************************************************
 */

/* Includes ------------------------------------------------------------------*/
#include <stdlib.h>
#include "ComponentsIDDef.h"
#include "graphicObject.h"
#include "LCDHAL.h"
#include "Drawbox.h"
#include "GxFreeGUI_Paint.h"

/* External variables --------------------------------------------------------*/
extern GL_Page_TypeDef *CurrentScreen;

/* Private variables ---------------------------------------------------------*/
GL_Page_TypeDef Page_Paint;
GL_PageControls_TypeDef* Drawbox;

/* Functions -----------------------------------------------------------------*/
void ButtonBLACK_Click(void)
{
  SetCurrentColor(Drawbox,GL_Black);
}

void ButtonBLUE_Click(void)
{
  SetCurrentColor(Drawbox,GL_Blue);
}

void ButtonCLEAR_Click(void)
{
  // Clear work area
  ClearDrawbox(Drawbox);
}

void ButtonCYAN_Click(void)
{
  SetCurrentColor(Drawbox,GL_Cyan);
}

void ButtonGREEN_Click(void)
{
  SetCurrentColor(Drawbox,GL_Green);
}

void ButtonMAGENTA_Click(void)
{
  SetCurrentColor(Drawbox,GL_Magenta);
}

void ButtonRED_Click(void)
{
  SetCurrentColor(Drawbox,GL_Red);
}

void ButtonWHITE_Click(void)
{
  SetCurrentColor(Drawbox,GL_White);
}

void ButtonYELLOW_Click(void)
{
  SetCurrentColor(Drawbox,GL_Yellow);
}

void Create_Paint(void)
{
  GL_PageControls_TypeDef* ButtonCLEAR   = NewButton(ID_Paint_ButtonCLEAR,"Clear",ButtonCLEAR_Click);
  GL_PageControls_TypeDef* ButtonBLACK   = NewButtonColor(ID_Paint_ButtonBLACK,GL_Black,ButtonBLACK_Click);
  GL_PageControls_TypeDef* ButtonBLUE    = NewButtonColor(ID_Paint_ButtonBLUE, GL_Blue, ButtonBLUE_Click);
  GL_PageControls_TypeDef* ButtonCYAN    = NewButtonColor(ID_Paint_ButtonCYAN, GL_Cyan, ButtonCYAN_Click);
  GL_PageControls_TypeDef* ButtonGREEN   = NewButtonColor(ID_Paint_ButtonGREEN,GL_Green,ButtonGREEN_Click);
  GL_PageControls_TypeDef* ButtonMAGENTA = NewButtonColor(ID_Paint_ButtonMAGENTA,GL_Magenta,ButtonMAGENTA_Click);
  GL_PageControls_TypeDef* ButtonRED     = NewButtonColor(ID_Paint_ButtonRED,  GL_Red,  ButtonRED_Click);
  GL_PageControls_TypeDef* ButtonWHITE   = NewButtonColor(ID_Paint_ButtonWHITE,GL_White,ButtonWHITE_Click);
  GL_PageControls_TypeDef* ButtonYELLOW  = NewButtonColor(ID_Paint_ButtonYELLOW,GL_Yellow,ButtonYELLOW_Click);
                           Drawbox       = NewDrawbox(ID_Paint_Drawbox,318,200,NULL);

  Create_PageObj( &Page_Paint );

  AddPageControlObj(318,  1,ButtonBLACK,  &Page_Paint);
  AddPageControlObj(288,  1,ButtonWHITE,  &Page_Paint);
  AddPageControlObj(258,  1,ButtonRED,    &Page_Paint);
  AddPageControlObj(228,  1,ButtonGREEN,  &Page_Paint);
  AddPageControlObj(198,  1,ButtonBLUE,   &Page_Paint);
  AddPageControlObj(168,  1,ButtonMAGENTA,&Page_Paint);
  AddPageControlObj(138,  1,ButtonCYAN,   &Page_Paint);
  AddPageControlObj(108,  1,ButtonYELLOW, &Page_Paint);
  AddPageControlObj( 78,  2,ButtonCLEAR,  &Page_Paint);
  AddPageControlObj(318, 35,Drawbox,      &Page_Paint);
}

void Show_Paint(void)
{
  if(CurrentScreen!=GL_NULL)
  {
    CurrentScreen->ShowPage(CurrentScreen,GL_FALSE);
  }
  GL_Clear(GL_White);
  GL_SetTextColor(GL_Black);
  Page_Paint.ShowPage(&Page_Paint, GL_TRUE);
  CurrentScreen=&Page_Paint;
}
